<?php
if ( !function_exists( 'add_action' ) ) {
    echo 'Hi there!  I\'m just a plugin, not much I can do when called directly.';
    exit;
}
/*
* Create Tab settings
*/
class Settings_Builder_Email_Backend {
    function __construct() {
        add_action('admin_enqueue_scripts', array($this,'style'));
        add_action( 'init', array($this,'create_posttype') );
        add_action( 'add_meta_boxes', array( $this, 'add_meta_boxes' ) );
        add_filter( 'get_sample_permalink_html', array( $this, 'remove_permalink' ) );
        add_action( 'save_post_email_template',array( $this, 'save_metabox' ), 10, 2 );
        add_filter( 'admin_body_class', array($this,'body_class' ));
        add_action( 'admin_footer', array($this,"add_page_templates"));
        add_action( 'builder_email_tool', array($this,"builder_email_tool_test_mail"));
        add_filter('post_row_actions', array($this,"duplicate_post_link"),10, 2);
        add_action( 'admin_action_rednumber_duplicate', array($this,"rednumber_duplicate") );

    }
    function builder_email_tool_test_mail(){
        ?>
        <div class="wp-builder-email-row-tool">
            <ul>
               <li><label><?php esc_html_e("Testing","wp-builder-email") ?>:</label></li>
               <li><input type="email" id="wpbuilder-email-testting" placeholder="Email"></li>
               <li><a href="#" class="button button-primary wpbuilder-email-testting-send"><?php esc_html_e("Send Email","wp-builder-email") ?></a></li>
            </ul>
        </div>
        <?php
    }
    function email_builder_main($post ) {
        $post_id= $post->ID;
        ?>
        <div id="builder-header">
            <div id="header-left">
                <div id="header-left-icon">
                    <a href="<?php echo admin_url("edit.php?post_type=email_template"); ?>"><i class="emailbuilder-icon icon-wordpress"></i></a>
                </div>
            </div>
            <div id="header-right">
                <div class="button wp-builder-email-choose-template">
                   <?php esc_html_e("Choose Templates","wp-builder-email")  ?>
                </div>
                <div class="button wp-builder-email-import">
                   <?php esc_html_e("Import","wp-builder-email")  ?>
                </div>
                <div class="button wp-builder-email-export">
                   <?php esc_html_e("Export","wp-builder-email")  ?>
                </div> 
                <div class="button wp-builder-email-export-html">
                   <?php esc_html_e("Export HTML","wp-builder-email")  ?>
                </div> 
                <div class="button">
                    <a target="_blank" href="<?php echo get_home_url() ."/?email_preview=preview&id=". $post_id ?>"><?php esc_html_e("Preview Email","wp-builder-email")  ?></a>
                </div>
                <div id="header-right-icon">
                    <a title="Save template" class="wp-email-builder-save" href="#"><i class="emailbuilder-icon icon-floppy"></i></a>
                </div>
            </div>
            <div class="clear"></div>
        </div>
        <div class="email-builder-container">
            <div class="wp-builder-email-slide">
                <div class="wp-builder-email-row-tool hidden">
                    <label><?php esc_html_e("Languages","wp-builder-email") ?>:</label>
                    <?php
                    if( isset($_GET["lang"]) && $_GET["lang"] != "") {
                        $active = $_GET["lang"];
                    }else{
                        $lang = get_post_meta($post_id,"wp_builder_lang",true);
                        if( $lang == ""){
                            $active = get_locale();
                        }else{
                            $active = $lang;
                        }
                        
                    }
                    if( $active == "en_US") {
                        $active = "en"; 
                    }                      
                    $lang_select = wp_dropdown_languages( array(
                        'class' => 'wp-builder-email-lang',
                        'id' => 'wp-builder-email-lang',
                        'name' => 'wp-builder-email-lang',
                        'languages' => get_available_languages(),
                        'selected' => $active,
                        'echo'      => true,
                        'show_available_translations' => false
                    )  ); ?>
                    
                </div>
                <div class="wp-builder-email-expand">
                        <a data-type="right" class="wp-email-builder-shrink" href="#"><?php esc_html_e("Shrink","wp-builder-email") ?> <i class="emailbuilder-icon icon-right-big"></i></a>
                </div>
                <?php echo do_action( "builder_email_tool" ,$post_id) ?>
            </div>
            <div class="email-builder-side">
                <div class="builder__right">
                        <div class="builder__widget">
                            <ul class="builder__tab">
                                <li><a class="" id="#tab__block"><i class="fa fa-th-large"></i><span><?php esc_html_e("Block","wp-builder-email")  ?></span> </a></li>
                                <li><a class="active" id="#tab__row"><i class="emailbuilder-icon icon-columns"></i><span><?php esc_html_e("Row","wp-builder-email")  ?></span></a></li>
                                <li><a class="" id="#tab__editor"><i class="emailbuilder-icon icon-pencil"></i><span><?php esc_html_e("Editor","wp-builder-email")  ?></span></a></li>
                            </ul>
                            <div class="tab__inner">
                                <div class="wp-builder-email-expand">
                                    <div class="wp-builder-email-expand-title"></div>
                                    <div class="wp-email-builder-expand-shrink">
                                        <a data-type="left" class="wp-email-builder-expand" href="#"><?php esc_html_e("Expand","wp-builder-email") ?> <i class="emailbuilder-icon icon-right-big"></i></a>
                                        <a data-type="left" class="wp-email-builder-shrink hidden" href="#"><?php esc_html_e("Shrink","wp-builder-email") ?> <i class="emailbuilder-icon icon-left-big"></i></a>
                                    </div>
                                    <div class="clear"></div>
                                </div>
                                <div class="tab__content " id="tab__block">
                                    <div class="builder__widget--inner">
                                        <ul class="momongaPresets">
                                            <?php echo do_action( "builder_email_tab_block" ) ?>
                                        </ul>
                                    </div>
                                </div>
                                <div class="tab__content active" id="tab__row">
                                    <div class="builder__widget--inner">
                                        <ul class="builder-row-tool">
                                            <?php echo do_action( "builder_email_tab_block_row" ) ?>
                                        </ul>
                                    </div>
                                </div>
                                <div class="tab__content" id="tab__editor">
                                    <div class="builder__editor">
                                        <?php echo do_action( "builder_email_tab__editor" ) ?>
                                    </div>
                                </div>
                            </div>
                        </div>

                    </div>
            </div>
            <?php 
            $user = get_option("_redmuber_item_29855785");
            if( $user == "ok"){
                ?>
                <div class="email-builder-main" data-type="main">
                    <div class="email-builder-main-change_backgroud" data-type="main"><i class="fa fa-pencil"></i> <?php esc_html_e("Background","wp-builder-email") ?></div>
                    <div class="builder__list builder__list--js"> 
                        <div class="builder-row-container builder__item">
                            <div style="background-color: #ffffff" data-background_full="not" data-type="row1" class="builder-row-container-row builder-row-container-row1">
                                <div class="builder-row builder-row-empty">
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="wpbuideremail-expand-right hidden">
                <a data-type="right" class="wp-email-builder-expand" href="#"><?php esc_html_e("Expand","wp-builder-email") ?> <i class="emailbuilder-icon icon-left-big"></i></a>
            </div>
            <?php 
                $data_js = get_post_meta( $post_id,'data_email',true);
            ?>
            <textarea name="data_email" class="data_email hidden"><?php echo esc_attr($data_js) ?></textarea>
            <textarea name="data_email_email" class="data_email_email hidden"></textarea>
            <script type="text/javascript">
                <?php
                    $data =array(); 
                    $datas = apply_filters("wp_email_builder_block_html",$data);
                ?>
                var wp_builder_email = <?php echo wp_json_encode($datas) ?>
            </script>
            <?php
        }else{
            echo '<div class="rednumber-show-active">
                    <p class="ntf">'.esc_html__("Please Enter Purchase code","wp-builder-email").'</p>
                    <p>'.esc_html__("Link Here","wp-builder-email").': <a href="'.admin_url("plugins.php").'">'.admin_url("plugins.php").'</a></p>   
                    <p><img src="'.BUIDER_EMAIL_PRO_PLUGIN_URL.'backend/images/enter_purchase_code.png" alt="" /><p>
                    <p>'.esc_html__("Link Here","wp-builder-email").': <a href="'.admin_url("plugins.php").'">'.admin_url("plugins.php").'</a></p>
                 </div>';
        }
        wp_enqueue_media();
    }
    function style() {
        $ver = time();
        $google_font = Settings_Builder_Email_Backend::google_font("link");
        wp_enqueue_style('wpbuilder-google-font', $google_font); 
        wp_enqueue_style('bootstrap-touchspin', plugins_url('lib/touchspin/jquery.bootstrap-touchspin.css', __FILE__),array());
        wp_enqueue_style('wpbuilder-font', plugins_url('css/wpbuideremail.css', __FILE__),array(),$ver);
        wp_enqueue_style('momonga', plugins_url('css/momonga.css', __FILE__),array("wp-color-picker","thickbox","bootstrap-touchspin"),$ver);
        wp_enqueue_style('wpbuilder-main', plugins_url('css/main.css', __FILE__),array(),$ver);

        wp_register_script('bootstrap-touchspin', plugins_url('lib/touchspin/jquery.bootstrap-touchspin.min.js', __FILE__),array());
        wp_register_script('wpbuilder_email_builder_main', plugins_url('src/main.js', __FILE__),array(), $ver);
        wp_register_script('wpbuilder_email_builder', plugins_url('src/builder.js', __FILE__),array("wpbuilder_email_builder_main"), $ver);
        wp_register_script('wpbuilder_email_editor', plugins_url('src/set_editor.js', __FILE__),array("wpbuilder_email_builder_main"), $ver);
        wp_enqueue_script('wpbuilder_email_script', plugins_url('src/script.js', __FILE__),array("jquery","wpbuilder_email_builder_main","jquery-ui-core","jquery-ui-sortable","jquery-ui-draggable","jquery-ui-droppable","wp-color-picker","wp-tinymce","wpbuilder_email_editor","wpbuilder_email_builder","thickbox","bootstrap-touchspin","jquery-effects-core","jquery-effects-scale"),$ver);
        $shortcode = array();
        $shortcode = apply_filters("wp_builder_email_shortcode",$shortcode);
        wp_localize_script( 'wpbuilder_email_script', 'wpbuilder_settings',
            array( 'ajax_url' => admin_url( 'admin-ajax.php' ), 
                'youtube_play_src' => BUIDER_EMAIL_PRO_PLUGIN_URL."images/youtube_play.png",
                'google_font_link' =>  $google_font,
                'shortcode' =>  $shortcode,
                'google_font_font_formats' => Settings_Builder_Email_Backend::google_font("font_formats"),
                 ) );
    }
    function create_posttype() {
        register_post_type( 'email_template',
            array(
                'labels' => array(
                    'name' => __( 'Email Templates',"wp-builder-email" ),
                    'singular_name' => __( 'email_templates',"wp-builder-email" )
                ),
                'public' => true,
                'has_archive' => true,
                'supports'    => array( 'title',"author" ),
                'show_in_menu' => true,
                'rewrite' => array('slug' => 'email_template'),
                'show_in_rest' => true,
                'menu_icon'           => 'dashicons-email',
                'menu_position'=>100,
            )
        );
    }
    function save_metabox($post_id, $post) {
        if( isset($_POST['data_email'])) {
            update_post_meta($post_id,'data_email',$_POST['data_email']);
        }
        if( isset($_POST['data_email_email'])) {
            update_post_meta($post_id,'data_email_email',$_POST['data_email_email']);
        }
        if( isset($_POST['wp-builder-email-lang'])) { 
            update_post_meta($post_id,'wp_builder_lang',sanitize_text_field($_POST['wp-builder-email-lang']));
        }   
    }
    function remove_view_action(){
        global $post_type;
        if ( 'email_template' === $post_type ) {
            unset( $actions['view'] );
        }
        return $actions;
    }
    function remove_permalink($link){
        global $post_type;
        if ( 'email_template' === $post_type ) {
            return "";
        }else{
            return $link;
        }
    }
    function add_meta_boxes() {
        add_meta_box(
            'email-builder-main',
            esc_html__( 'Builder Email', 'wp-email-builder' ),
            array( $this, 'email_builder_main' ),
            'email_template',
            'normal',
            'default'
        );
    }
    function body_class( $classes ) {
        global $post_type;
        $screen = get_current_screen();
        if ( 'email_template' == $post_type && $screen->id == 'email_template' ) {
            return  $classes . " post-php";
        }else{
            return  $classes;
        }
    }
    function add_page_templates(){
        add_thickbox(); 
        ?>
        <div id="wp-builder-email-templates" style="display:none">
          <div class="list-view-templates">
              <?php 
              $args = array(
                    "json"=>"",
                    "img"=>BUIDER_EMAIL_PRO_PLUGIN_URL."backend/demo/template1/1.png",
                    "title"=>"Email templates",
                    "cat" => array(),
                    "id"=>0,
                );
              do_action( "builder_email_templates" );
               ?>
          </div>       
        </div>
        <?php
    }
    public static function item_demo($args1){
        $defaults = array(
            "json"=>"",
            "img"=>BUIDER_EMAIL_PRO_PLUGIN_URL."backend/demo/template1/1.png",
            "title"=>"Email templates",
            "url" => "#",
            "id"=>0,
            "cat" => array(),
        );
        $args = wp_parse_args( $args1, $defaults );
        $domain = "https://dev.wall-f.com/wpbuideremail/";
        $url_view = $domain."?email_preview=preview&id=".$args["id"];
        $url_design = $domain."?templates_id=".$args["id"];
        ?>
         <div class="grid-item" data-file="<?php echo esc_url($args["json"]) ?>">
              <img src="<?php echo esc_url($args["img"]) ?>">
              <div class="demo_content">
                  <div class="demo-title"><?php echo esc_html($args["title"]) ?></div>
                  <div class="demo-tags"><?php echo implode(", ",$args["cat"]) ?></div>
                  <div class="wp-builder-email-actions">
                        <div class="demo-fl">
                            <a class="button wp-builder-email-actions-import" href="#"><?php esc_html_e("Import","wp-builder-email") ?></a>
                            <a target="_blank" class="button wp-builder-email-actions-design" href="<?php echo esc_url($url_design) ?>"><?php esc_html_e("Design","wp-builder-email") ?></a>
                        </div>
                        <div class="demo-fr">
                            <a target="_blank" class="button wp-builder-email-actions-view" href="<?php echo esc_url($url_view) ?>"><?php esc_html_e("Preview","wp-builder-email") ?></a>
                        </div>
                        <div class="clear"></div>
                      
                  </div>
              </div>
              
          </div>
        <?php
    }
    public static function google_font($type){
        switch ($type) {
            case "link":
                return 'https://fonts.googleapis.com/css?family=Lato|Roboto|Oswald|Raleway|Open+Sans&display=swap';
                break;
            case "font_formats":
                return "Arial=Arial; Arial Black=Arial Black; Helvetica=Helvetica; Tahoma=Tahoma; Times New Roman=Times New Roman; Lato=lato; Oswald=Oswald; Raleway=Raleway; Open Sans=Open Sans; Roboto=Roboto;";
                break;
            case "add_css":
                return array(
                    "Lato","Roboto","Oswald","Raleway","Open+Sans"
                );
                break;
            default:
                return 'https://fonts.googleapis.com/css2?family=Lato&family=Roboto&family=Oswald&family=Raleway&family=Open+Sans&display=swap';
                break;
        }
    }
    function duplicate_post_link($actions, $post){
        if ($post->post_type=='email_template' && current_user_can('edit_posts') ){
            $actions['duplicate'] = '<a href="' . wp_nonce_url('admin.php?action=rednumber_duplicate&post=' . $post->ID, basename(__FILE__), 'duplicate_nonce' ) . '" title="Duplicate this item" rel="permalink">Duplicate</a>';
            $actions['preview_template'] = '<a target="_blank" href="' . esc_url(get_home_url()."?email_preview=preview&id=".$post->ID) . '" title="Preview" rel="Preview">Preview</a>';
        }
        return $actions;
    }
    function rednumber_duplicate(){
      global $wpdb;
      if (! ( isset( $_GET['post']) || isset( $_POST['post'])  || ( isset($_REQUEST['action']) && 'rednumber_duplicate' == $_REQUEST['action'] ) ) ) {
        wp_die('No post to duplicate has been supplied!');
      }
      $post_id = (isset($_GET['post']) ? absint( $_GET['post'] ) : absint( $_POST['post'] ) );
      $post = get_post( $post_id );
      $current_user = wp_get_current_user();
      $new_post_author = $current_user->ID;
      if (isset( $post ) && $post != null) {
        $args = array(
          'comment_status' => $post->comment_status,
          'ping_status'    => $post->ping_status,
          'post_content'   => $post->post_content,
          'post_excerpt'   => $post->post_excerpt,
          'post_name'      => $post->post_name,
          'post_parent'    => $post->post_parent,
          'post_password'  => $post->post_password,
          'post_status'    => 'Publish',
          'post_title'     => $post->post_title ."-Demo",
          'post_type'      => $post->post_type,
          'to_ping'        => $post->to_ping,
          'menu_order'     => $post->menu_order
        );
        $new_post_id = wp_insert_post( $args );
        $post_meta_infos = $wpdb->get_results("SELECT meta_key, meta_value FROM $wpdb->postmeta WHERE post_id=$post_id");
        if (count($post_meta_infos)!=0) {
          $sql_query = "INSERT INTO $wpdb->postmeta (post_id, meta_key, meta_value) ";
          foreach ($post_meta_infos as $meta_info) {
            $meta_key = $meta_info->meta_key;
            if( $meta_key == '_wp_old_slug' ) continue;
            $meta_value = addslashes($meta_info->meta_value);
            $sql_query_sel[]= "SELECT $new_post_id, '$meta_key', '$meta_value'";
          }
          $sql_query.= implode(" UNION ALL ", $sql_query_sel);
          $wpdb->query($sql_query);
        }
        wp_redirect( admin_url( 'post.php?action=edit&post=' . $new_post_id ) );
        exit;
      } else {
        wp_die('Post creation failed, could not find original post: ' . $post_id);
      }
    }
}
new Settings_Builder_Email_Backend;