<?php
if ( !function_exists( 'add_action' ) ) {
    echo 'Hi there!  I\'m just a plugin, not much I can do when called directly.';
    exit;
}
class WPBuilder_Email_Settings {
	function __construct() { 
		 add_action( 'admin_menu', array( $this, 'add_plugin_page' ) );
	}
	function add_plugin_page(){
		add_submenu_page('edit.php?post_type=email_template','Settings', 'Settings', 'manage_options','wpbuilder-email-settings', array($this,'settings_page')  );
		add_action( 'admin_init', array($this,'register_settings') );
	}
	function settings_page(){
		$languages = get_available_languages();
		$languages = wp_parse_args( array("en"), $languages );
		$data = get_option("wpbuider_email");
		?>
		<div class="wrap">
		<h1><?php esc_html_e("Email Templates","wp-email-builder") ?></h1>

		<form method="post" action="options.php">
		    <?php settings_fields( 'wpbuider_email' ); ?>
		    <?php do_settings_sections( 'wpbuider_email' ); ?>
		    <table class="form-table">
		    	<?php foreach ($languages as $language) { ?>
		        <tr valign="top">
			        <th scope="row"><?php esc_html_e("Email Templates","wp-email-builder") ?> - <?php esc_html_e($language) ?></th>
			        <td>
			        	<div class="wp-core-ui">
			        		<select name="wpbuider_email[<?php echo esc_attr($language) ?>]">
			        			<option>-----</option>
			        			<?php 
			        			$the_query = new WP_Query( array('post_type' => 'email_template',"posts_per_page"=>-1) ); 
			        			while ( $the_query->have_posts() ) : $the_query->the_post();
			        				$id = get_the_ID()
			        			?>
			        			<option <?php selected($id,$data[$language],true) ?> value="<?php echo esc_attr($id) ?>"><?php the_title(); ?></option>
			        			<?php
			        			endwhile;
			        			wp_reset_postdata();	
			        			?>
			        			
			        		</select>
			        	</div>
			        </td>
		        </tr>
		    <?php }?>
		    </table>
		    <?php submit_button(); ?>
		</form>
		</div>
		<?php
	}
	function register_settings(){
		register_setting( 'wpbuider_email', 'wpbuider_email' );
	}
	
}
new WPBuilder_Email_Settings;
