<?php
if ( !function_exists( 'add_action' ) ) {
    echo 'Hi there!  I\'m just a plugin, not much I can do when called directly.';
    exit;
}
class WPBuilder_Email_frontend {
	function __construct(){
       add_filter( 'template_include',array($this,'template_include'),99);
       add_filter('wp_mail',array($this,"email_template"));
       add_filter( 'wp_mail_content_type',array($this,'set_content_type') );
       add_filter('upload_mimes', array($this,'mime_types'));
       add_filter("wpbuider_email_id",array($this,"set_id_send_email"),10);
    }
    function set_id_send_email($emails){
		preg_match_all('/data-wpbuilderemailid="([^"]*)"/',$emails["message"],$matches);
		if( is_numeric($matches[1][0]) ){
			$emails["apply"] = false;
		}
		return $emails;
	}
    function template_include($template) {
	    if( isset($_GET['email_preview']) ){
	        if( $_GET['email_preview'] == "preview") {
	             $template = BUIDER_EMAIL_PRO_PLUGIN_PATH."preview.php";   
	        }else{
	             $template = BUIDER_EMAIL_PRO_PLUGIN_PATH."preview-inner.php";   
	        }
	        if ( file_exists( $template ) ) { 
	            return $template;
	        }
	    }else{
	     	return $template;
	    }
	}
	function email_template($args) {
	    $message =  $args["message"];
	    if( is_numeric($message) ){
	    	//Test email
	    	ob_start();
		    include BUIDER_EMAIL_PRO_PLUGIN_PATH."email-templates/header.php";
		    echo do_shortcode(get_post_meta( $message,'data_email_email',true));
		    include BUIDER_EMAIL_PRO_PLUGIN_PATH."email-templates/footer.php";
		    $content = ob_get_contents();
		    ob_end_clean();
		    $args["message"] = $content;
	    }else{
	    	$data = get_option("wpbuider_email");
	    	$active = get_locale();
	    	$mails = apply_filters( "wpbuider_email_id", array("apply"=>true,"message"=>$message));
	        if( $mails["apply"]  ) {
	        	//no email apply
	        	if( $active == "en_US") {
		            $active = "en"; 
		        }
		        //check mail template
		        if( is_numeric($data[$active]) ) { 
		        	ob_start();
				    include BUIDER_EMAIL_PRO_PLUGIN_PATH."email-templates/header.php";
				    echo do_shortcode(get_post_meta( $data[$active],'data_email_email',true));
				    include BUIDER_EMAIL_PRO_PLUGIN_PATH."email-templates/footer.php";
				    $content = ob_get_contents();
				    ob_end_clean();
				    $args["message"] = str_replace('<div class="builder-content">Content Email</div>',$message,$content);
		        }
	        }else{
	        	//adon-change email
	        	ob_start();
			    include BUIDER_EMAIL_PRO_PLUGIN_PATH."email-templates/header.php";
			    echo do_shortcode($message);
			    include BUIDER_EMAIL_PRO_PLUGIN_PATH."email-templates/footer.php";
			    $content = ob_get_contents();
			    ob_end_clean();
			    $args["message"] = $content;
	        }
	    }
	    return $args;
	}
	function set_content_type(){
	    return "text/html";
	}
	function mime_types($mimes) {
	    $mimes['json'] = 'text/plain';
	    return $mimes;
	}

}
new WPBuilder_Email_frontend;