(function($) {
    "use strict";
    $( document ).ready( function () { 
    	var ajax_change_editor = null;
        $("input.touchspin").TouchSpin({
            min: 0,
            max: 1000,
            boostat: 5,
            maxboostedstep: 10,
        });
        //upload IMG
        $('body').on('click', '.upload-editor--image', function(e){
            e.preventDefault();
            var input = $(this).closest(".builder__editor--button-url").find(".image_url");
                var button = $(this),
                    custom_uploader = wp.media({
                title: 'Insert image',
                library : {
                    type : 'image'
                },
                button: {
                    text: 'Use this image' // button label text
                },
                multiple: false // for multiple image selection set to true
            }).on('select', function() { // it also has "open" and "close" events 
                var attachment = custom_uploader.state().get('selection').first().toJSON();
                input.val(attachment.url).change();
                var img = new Image();
                img.src = attachment.url;
                img.onload = function() {
                  var pr_width = $(".wp_builder_email_focus").width();
                  if( this.width >  pr_width ){
                        var pe = this.width / pr_width;
                        $(".builder__editor--item-width .text_width").val(pr_width);
                        $(".builder__editor--item-height .text_height").val(this.height/pe).change();
                  }else{
                        $(".builder__editor--item-width .text_width").val(this.width);
                        $(".builder__editor--item-height .text_height").val(this.height).change();
                  }
                } 
            })
            .open();
        });
        
        //Menu
        $('body').on("click",".wpbuilder_email_add_menu",function(e){
             e.preventDefault();
             var data =$(".builder__editor--item-menu-hidden").html();
             $(".menu-content-tool>ul").append("<li class='data'>"+data+"</li>"); 
             $('.menu-content-tool .text_background,.menu-content-tool .text_color').wpColorPicker({
                change: function(event, ui){
                    $(".wp_builder_email_focus").wpbuilder_set_type_editor();
                    if( $(".wp_builder_email_focus").attr("background_full") == "ok" ){
                        $(".wp_builder_email_focus").closest(".builder-row-container").css("background-color",$(".wp_builder_email_focus").css("background-color"));
                    }else{
                        $(".wp_builder_email_focus").closest(".builder-row-container").css("background-color","transparent");
                    }     
                }
            });  
        })



        //Editor Change
        $('body').on("change",".builder__editor input",function(e){
             e.preventDefault();
             $(".wp_builder_email_focus").wpbuilder_set_type_editor();
                if( $(".wp_builder_email_focus").attr("background_full") == "ok" ){
                    $(".wp_builder_email_focus").closest(".builder-row-container").css("background-color",$(".wp_builder_email_focus").css("background-color"));
                }else{
                    $(".wp_builder_email_focus").closest(".builder-row-container").css("background-color","transparent");
                }    
        })

        //align
         $('body').on("click",".builder__editor--align a",function(e){
             e.preventDefault();
             $(".builder__editor--align a").removeClass("active");
             $(this).addClass("active");
             var vl = $(this).data("value");
             $(this).closest(".builder__editor--align").find(".text_align").val(vl).change();
        })
         //text
         tinymce.init({
            selector: '.builder__editor--js',
            mode: 'exact',
            content_style: "@import url('"+wpbuilder_settings.google_font_link+"'); body { font-family: 'Arial', sans-serif;background:#eeeeee;} h1,h2,h3,h4,h5,h6 { font-family: 'Arial black', sans-serif; }",
            font_formats: wpbuilder_settings.google_font_font_formats,
            height: 'auto',
            menubar: false,
            statusbar: false,
            relative_urls: false,
            remove_script_host: false,
            convert_urls: false,
            plugins: ["link textcolor colorpicker image"],
            toolbar:
                [
                    'bold italic underline | fontselect styleselect | link image',
                    'fontsizeselect forecolor backcolor',
                    'shortcodes icons'
                ],   
            fontsize_formats: '10px 11px 12px 13px 14px 15px 16px 17px 18px 19px 20px 22px 24px 26px 28px 30px 35px 40px 50px 60px',
            setup:function(ed) {
                ed.addButton('shortcodes', {
                        type: 'listbox',
                        text: 'Shortcodes',
                        onselect: function (e) {
                            ed.insertContent(this.value())
                        },
                        values: wpbuilder_settings.shortcode,
                    });
                ed.addButton('icons', {
                        onclick: function() {
                            ed.windowManager.open( {
                                title: 'Insert icon',
                                body: [{
                                    type: 'textbox',
                                    name: 'icon',
                                    label: 'Icon'
                                },
                                {
                                    type: 'textbox',
                                    name: 'size',
                                    label: 'Size'
                                },
                                {
                                    type: 'textbox',
                                    name: 'color',
                                    label: 'Color'
                                },
                                ],
                                onsubmit: function( e ) {
                                    ed.insertContent( '&lt;h3&gt;' + e.data.title + '&lt;/h3&gt;');
                                }
                            });
                        }
                    });
                ed.on('change keyup', function(e) {
                    var data = {
                        'action': 'wpemail_builder_text',
                        'text': ed.getContent(),
                    };
                    $(".builder-elements-content.wp_builder_email_focus .text-content-data").html(ed.getContent()); 
                    $(".builder-elements-content.wp_builder_email_focus .text-content").html(ed.getContent()); 
                    if( ajax_change_editor != null){
                        ajax_change_editor.abort();
                    }
                    ajax_change_editor = $.post(ajaxurl, data, function(response) {
                        $(".builder-elements-content.wp_builder_email_focus .text-content").html(response); 
                    });
                   
                });
            }
        });
         //color
          $('.builder__editor_color').wpColorPicker({
            change: function(event, ui){
                $(".wp_builder_email_focus").wpbuilder_set_type_editor();
                if( $(".wp_builder_email_focus").attr("background_full") == "ok" ){
                    $(".wp_builder_email_focus").closest(".builder-row-container").css("background-color",$(".wp_builder_email_focus").css("background-color"));
                }else{
                    $(".wp_builder_email_focus").closest(".builder-row-container").css("background-color","transparent");
                }    
            }
        });
        

        $.selector_element = function(){
            var button_tab = $('.builder__tab li a');
            button_tab.each(function () {
                var button = $(this);
                if(button.attr('id') == '#tab__editor' ) {
                    $('.builder__tab li a').removeClass('active');
                    button.addClass('active');
                    var tab = $(button.attr('id'));
                    $('.tab__content').hide();
                    tab.show();
                }
            });
            $('.builder__toolbar').remove();
            $(".builder__editor--item").addClass("hidden");
            $("div").removeClass("wp_builder_email_focus").removeClass("wp_builder_email_show");
        }


        ///Get ----------------------------------------
        $('body').on("click",".email-builder-main-change_backgroud",function(e){ 
            e.preventDefault();
            e.stopPropagation();
            $.selector_element();
            $(".email-builder-main").addClass("wp_builder_email_focus wp_builder_email_show");
            $(".email-builder-main").wpbuilder_load_type_editor(true);

        })

        //click out 
        $('body').on("click",".builder__tab,.wp-builder-email-slide,.builder-actions,#builder-header,#titlediv",function(e){
            $("div").removeClass('wp_builder_email_show wp_builder_email_focus');
            $("div").remove(".builder__toolbar");
            $(".builder__editor--item").addClass('hidden');
        })

        $('body').on("click",".builder-elements-content",function(e){
            e.preventDefault();
            e.stopPropagation();
            $.selector_element();
            var toolbar= $('<div class="builder__toolbar">' +
            '<div class="momongaDragHandle"><i class="emailbuilder-icon icon-menu-1"></i></div>' +
            '<div class="momongaEdit"><i class="emailbuilder-icon icon-pencil"></i></div>' +
            '<div class="momongaDuplicate"><i class="emailbuilder-icon icon-docs"></i></div>' +
            '<div class="momongaDelete"><i class="emailbuilder-icon icon-trash"></i></div>' +
            '</div>');
            $(this).addClass("wp_builder_email_focus");
            $(this).closest(".builder-row-container").addClass("wp_builder_email_show");
            $(this).append(toolbar.clone());
            $(this).closest(".builder-row-container").append(toolbar);
            $(this).wpbuilder_load_type_editor();
        })
        $("body").on("click",".momongaEdit",function(e){
            e.preventDefault();
            $(this).closest('.builder__toolbar').parent( ".builder-row-container").find(".builder-row-container-row").click();
        })
        $('body').on("click",".builder-row-container-row",function(e){
            e.preventDefault();
            e.stopPropagation();
            $.selector_element();

            var toolbar= $('<div class="builder__toolbar">' +
            '<div class="momongaDragHandle"><i class="emailbuilder-icon icon-menu-1"></i></div>' +
            '<div class="momongaEdit"><i class="emailbuilder-icon icon-pencil"></i></div>' +
            '<div class="momongaDuplicate"><i class="emailbuilder-icon icon-docs"></i></div>' +
            '<div class="momongaDelete"><i class="emailbuilder-icon icon-trash"></i></div>' +
            '</div>');

            $(this).addClass("wp_builder_email_focus");
            $(this).closest(".builder-row-container").addClass('wp_builder_email_show');

            $(this).closest(".builder-row-container").removeClass('.builder-row-empty');

            $.check_row_empty();

            $(this).closest(".builder-row-container").append(toolbar);
            $(this).wpbuilder_load_type_editor(true);
        })
        $.check_row_empty = function() {
            $( ".builder-row-container" ).each(function( index ) {
                    $(this ).find(".builder-row").each(function( index ) { 
                        var check = $(this).find('.builder-elements');
                        if( check.length > 0 ){
                            $(this).removeClass('builder-row-empty');
                            $(this).closest('.builder-row-container').removeClass('builder-row-empty');
                        }
                    })
            });
        }
})
})(jQuery);