<?php
class Wpbuilder_email_editor {
    function __construct(){
      add_action("builder_email_tab__editor",array($this,"builder_email_tab__editor"));  
    }
    public static function get_color_pick($text = "Color Pick"){
        return '<div class="builder__editor--color">
                <label>'.$text.'</label>
                <div class="">
                    <input type="text" value="#e7e7e7" class="builder__editor_color">
                </div>
            </div>';
    }
    public static function get_padding() {
        return '<div class="builder__editor--padding">
                <div>
                    <label>'.esc_html__("Top","wp-builder-email").'</label>
                    <input data-after_value="px" class="builder__editor--padding-top touchspin" type="text" placeholder="px" />
                </div>
                <div>
                    <label>'. esc_html__("Bottom","wp-builder-email").'</label>
                    <input data-after_value="px" class="builder__editor--padding-bottom touchspin" type="text" placeholder="px" />
                </div>
                <div>
                    <label>'.esc_html__("Left","wp-builder-email").'</label>
                    <input data-after_value="px" class="builder__editor--padding-left touchspin" type="text" placeholder="px" />
                </div>
                <div>
                    <label>'.esc_html__("Right","wp-builder-email").'</label>
                    <input data-after_value="px" class="builder__editor--padding-right touchspin" type="text" placeholder="px" />
                </div>
            </div>';
    }
    function builder_email_tab__editor(){
        ?>
        
        <div class="builder__editor--item builder__editor--item-html">
            <div class="builder__editor--html">
                <label><?php esc_html_e("Content","wp-builder-email") ?></label>
                <textarea class="builder__editor--js"></textarea>
            </div>
        </div>
        <div class="builder__editor--item builder__editor--item-video">
            <div class="builder__editor--video">
                <label><?php esc_html_e("Youtube","wp-builder-email") ?></label>
                <input type="text" class="video_url">
            </div>
        </div>
        <div class="builder__editor--item builder__editor--item-image">
            <label><?php esc_html_e("Image","wp-builder-email") ?></label>
            <div class="builder__editor--button-url">
                <label><?php esc_html_e("Source URL","wp-builder-email") ?></label>
                <input type="text" class="image_url" placeholder="Source url">
                <input type="button" class="upload-editor--image button button-primary" value="Upload">
            </div>
            <div class="builder__editor--button-url">
                <label><?php esc_html_e("Alt","wp-builder-email") ?></label>
                <input type="text" class="image_alt" placeholder="Image alt" >
            </div>
        </div>
        <div class="builder__editor--item builder__editor--item-button">
            <div class="builder__editor--button">
                <label><?php esc_html_e("Button","wp-builder-email") ?></label>
                <div class="builder__editor--button-text">
                    <label><?php esc_html_e("Button text","wp-builder-email") ?></label>
                    <input type="text" class="button_text" value="Button text">
                </div>
                <div class="builder__editor--button-url">
                    <label><?php esc_html_e("Button url","wp-builder-email") ?></label>
                    <input type="text" class="button_url" placeholder="Button url" >
                </div>
                <div class="builder__editor--button-range">
                    <label><?php esc_html_e("Font size","wp-builder-email") ?></label>
                    <input data-after_value="px" type="text" value="16" class="font_size touchspin" min="10" max="30">
                </div>
            </div>
        </div>
        <div class="builder__editor--item builder__editor--item-background">
            <?php echo Wpbuilder_email_editor::get_color_pick(esc_html__("Background color","wp-builder-email")) ?>
            <div class="builder__editor--button-url">
                <label><?php esc_html_e("Background Image","wp-builder-email") ?></label>
                <input type="text" class="image_url" placeholder="Source url">
                <input type="button" class="upload-editor--image button button-primary" value="Upload">
            </div>
        </div>
        <div class="builder__editor--item builder__editor--item-background_full">
            <label><?php esc_html_e("Background Full Width","wp-builder-email") ?></label>
                    <input type="checkbox" class="background_full_width" >
        </div>
        <div class="builder__editor--item builder__editor--item-color">
            <?php echo Wpbuilder_email_editor::get_color_pick(esc_html__("Color","wp-builder-email")) ?>
        </div>
        <div class="builder__editor--item builder__editor--item-menu">
            <div class="builder__editor--item-menu-hidden hidden">
                <ul>
                    <li>
                        <label><?php esc_html_e("Text","wp-builder-email") ?></label>
                        <input type="text" class="text"> 
                    </li>
                    <li>
                        <label><?php esc_html_e("Url","wp-builder-email") ?></label>
                        <input type="text" class="text_url">
                    </li>
                    <li>
                        <label><?php esc_html_e("Background","wp-builder-email") ?></label>
                         
                        <input type="text" class="text_background" value="transparent">
                    </li>
                    <li>
                         <label><?php esc_html_e("Color","wp-builder-email") ?></label>
                            <input type="text" value="#fff" class="text_color"> 
                    </li>
                </ul>
            </div>
           <div class="menu-content-tool">
               
           </div>
            <a class="wpbuilder_email_add_menu button button-primary" href="#"><?php esc_html_e("Add menu","wp-builder-email") ?></a>
        </div>
        <div class="builder__editor--item builder__editor--item-social">
            <label><?php esc_html_e("Social","wp-builder-email") ?></label>
            <div class="builder__editor--social-facebook">
                <div class="builder__editor--button-url">
                    <label><?php esc_html_e("URL Facebook","wp-builder-email") ?></label>
                    <input type="text" class="social_url" placeholder="URl" >
                </div>
                <div class="builder__editor--button-url">
                    <label><?php esc_html_e("Show/ hide","wp-builder-email") ?></label>
                    <input type="checkbox" class="social_show" >
                </div>
            </div>
            <div class="builder__editor--social-twitter">
                <div class="builder__editor--button-url">
                    <label><?php esc_html_e("URL Twitter","wp-builder-email") ?></label>
                    <input type="text" class="social_url" placeholder="URl" >
                </div>
                <div class="builder__editor--button-url">
                    <label><?php esc_html_e("Show/ hide","wp-builder-email") ?></label>
                    <input type="checkbox" class="social_show" >
                </div>
            </div>
            <div class="builder__editor--social-instagram">
                <div class="builder__editor--button-url">
                    <label><?php esc_html_e("URL Instagram","wp-builder-email") ?></label>
                    <input type="text" class="social_url" placeholder="URl" >
                </div>
                <div class="builder__editor--button-url">
                    <label><?php esc_html_e("Show/ hide","wp-builder-email") ?></label>
                    <input type="checkbox" class="social_show" >
                </div>
            </div>
            
            <div class="builder__editor--social-linkedin">
                <div class="builder__editor--button-url">
                    <label><?php esc_html_e("URL Linkedin","wp-builder-email") ?></label>
                    <input type="text" class="social_url" placeholder="URl" >
                </div>
                <div class="builder__editor--button-url">
                    <label><?php esc_html_e("Show/ hide","wp-builder-email") ?></label>
                    <input type="checkbox" class="social_show" >
                </div>
            </div>
            <div class="builder__editor--social-whatsapp">
                <div class="builder__editor--button-url">
                    <label><?php esc_html_e("URL Whatsapp","wp-builder-email") ?></label>
                    <input type="text" class="social_url" placeholder="URl" >
                </div>
                <div class="builder__editor--button-url">
                    <label><?php esc_html_e("Show/ hide","wp-builder-email") ?></label>
                    <input type="checkbox" class="social_show" >
                </div>
            </div>
            <div class="builder__editor--social-youtube">
                <div class="builder__editor--button-url">
                    <label><?php esc_html_e("URL Whatsapp","wp-builder-email") ?></label>
                    <input type="text" class="social_url" placeholder="URl" >
                </div>
                <div class="builder__editor--button-url">
                    <label><?php esc_html_e("Show/ hide","wp-builder-email") ?></label>
                    <input type="checkbox" class="social_show" >
                </div>
            </div>
        </div>
        <div class="builder__editor--item builder__editor--item-text-align">
            <label><?php esc_html_e("Text align","wp-builder-email") ?></label>
            <div class="builder__editor--align">
                
                <a class="button__align builder__editor--align-left" data-value="left"><i class="emailbuilder-icon icon-align-left"></i></a>
                <a class="button__align builder__editor--align-center" data-value="center"><i class="emailbuilder-icon icon-align-justify"></i></a>
                <a class="button__align builder__editor--align-right" data-value="right"><i class="emailbuilder-icon icon-align-right"></i></a>
                <input type="text" value="left" class="text_align hidden">
            </div>
        </div>
        <div class="builder__editor--item builder__editor--item-width">
            <label><?php esc_html_e("Width","wp-builder-email") ?></label>
            <input data-after_value="px" type="text" class="text_width touchspin">
        </div>
        <div class="builder__editor--item builder__editor--item-height">
            <label><?php esc_html_e("Height","wp-builder-email") ?></label>
            <input data-after_value="px" type="text" class="text_height touchspin">
        </div>
        <div class="builder__editor--item builder__editor--item-padding">
            <label><?php esc_html_e("Padding","wp-builder-email") ?></label>
            <?php echo Wpbuilder_email_editor::get_padding() ?>
        </div>
        <div class="builder__editor--item builder__editor--item-margin">
            <label><?php esc_html_e("Margin","wp-builder-email") ?></label>
            <?php echo Wpbuilder_email_editor::get_padding() ?>
        </div>
        <div class="builder__editor--item builder__editor--item-border">
            <label><?php esc_html_e("Border","wp-builder-email") ?></label>
            <label><?php esc_html_e("Border Width","wp-builder-email") ?></label>
            <div class="builder__editor--item-border-width">
                <?php echo Wpbuilder_email_editor::get_padding() ?>

                <label class="hidden"><?php esc_html_e("Border Style","wp-builder-email") ?></label>
                <input type="text" value="solid" class="border_style hidden">
                <?php echo Wpbuilder_email_editor::get_color_pick(esc_html__("Border color","wp-builder-email")) ?> 
            </div>

            <label><?php esc_html_e("Border radius","wp-builder-email") ?></label>
            <div class="builder__editor--item-border-radius">
                <?php echo Wpbuilder_email_editor::get_padding() ?>
            </div>
            
        </div>
        
        <?php
    }
}
new Wpbuilder_email_editor();